/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>

char be[] =
	"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567";

char be2[] =
	"abcdefghijklmnopqrstuvwxyz";

void
b32enc(int in, int out)
{
	char s[6], o[9];
	int l;

	memset(s, 0, 6);
	memset(o, 0, 9);

	while((l = readn(in, s, 5)) > 0) {
		o[0] = be[(s[0] >> 3) & 0x1F];
		o[1] = be[(s[0] << 2) & 0x1C | (s[1] >> 6) & 0x03];
		o[2] = be[(s[1] >> 1) & 0x1F];
		o[3] = be[(s[1] << 4) & 0x10 | (s[2] >> 4) & 0x0F];
		o[4] = be[(s[2] << 1) & 0x1E | (s[3] >> 7) & 0x01];
		o[5] = be[(s[3] >> 2) & 0x1F];
		o[6] = be[(s[3] << 3) & 0x18 | (s[4] >> 5) & 0x07];
		o[7] = be[s[4] & 0x1F];

		switch(l) {
		case 1:
			o[2] = o[3] = '=';
		case 2:
			o[4] = o[5] = '=';
		case 3:
			o[6] = '=';
		case 4:
			o[7] = '=';
		default:
			break;
		}
		write(out, o, 8);

		memset(s, 0, 6);
		memset(o, 0, 9);
	}
}

void
b32dec(int in, int out)
{
	char bd[256], s[9], o[6];
	int l;

	l = -1;
	memset(bd, 0x80, 256);
	while(++l < strlen(be))
		bd[be[l]] = l;
	l = -1;
	while(++l < strlen(be2))
		bd[be2[l]] = l;
	bd['='] = 0;

	memset(s, 0, 9);
	memset(o, 0, 6);

	while(readn(in, s, 8) >= 8) {
		o[0] = (bd[s[0] & 0xFF] << 3) | (bd[s[1] & 0xFF] >> 2);
		o[1] = (bd[s[1] & 0xFF] << 6) | (bd[s[2] & 0xFF] << 1) | (bd[s[3] & 0xFF] >> 4);
		o[2] = (bd[s[3] & 0xFF] << 4) | (bd[s[4] & 0xFF] >> 1);
		o[3] = (bd[s[4] & 0xFF] << 7) | (bd[s[5] & 0xFF] << 2) | (bd[s[6] & 0xFF] >> 3);
		o[4] = (bd[s[6] & 0xFF] << 5) | bd[s[7] & 0xFF];

		l = 5;
		if(s[7] == '=')
			l = 4;
		if(s[6] == '=')
			l = 3;
		if(s[5] == '=' && s[4] == '=')
			l = 2;
		if(s[3] == '=' && s[2] == '=')
			l = 1;
		write(out, o, l);

		memset(s, 0, 9);
		memset(o, 0, 6);
	}
}

void
usage(void)
{
	print("usage: [-d]\n");
	exits(0);
}

void
main(int argc, char *argv[])
{
	int dec;

	dec = 0;

	ARGBEGIN {
		case 'd':
			dec = 1;
			break;
		default:
			usage();
	} ARGEND;

	if(dec)
		b32dec(0, 1);
	else
		b32enc(0, 1);

	exits(0);
}
